package com.cassidian.natess.chart.provider;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.steema.teechart.TChart;
import com.steema.teechart.axis.Axis;
import com.steema.teechart.styles.Line;

/**
 * First zoom in, and then push the button to add a custom axis. Afterwards zoom out, to reproduce an
 * ArrayIndexOutOfBoundsException.
 *
 * @author slix
 *
 */
public class TestChartAxis {

	protected Shell shell;

	/**
	 * Launch the application.
	 *
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			TestChartAxis window = new TestChartAxis();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shell = new Shell();
		shell.setSize(450, 300);
		shell.setText("SWT Application");
		shell.setLayout(new FillLayout());
		final TChart chart = new TChart(shell, SWT.NONE);
		chart.getAspect().setView3D(false);

		Line l = new Line(chart.getChart());
		l.fillSampleValues();

		Button b = new Button(shell, SWT.NONE);
		b.setText("First zoom in, and then push this big button to add a custom axis. Afterwards zoom out, to reproduce an ArrayIndexOutOfBoundsException.");
		b.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Axis teeVerticalAxis = new com.steema.teechart.axis.Axis(chart.getChart());
				teeVerticalAxis.getGrid().setVisible(false);
				teeVerticalAxis.getTitle().setText("TestAxis");
				chart.getAxes().getCustom().add(teeVerticalAxis);

				Line l1 = new Line(chart.getChart());
				l1.fillSampleValues();
				l1.setCustomVertAxis(teeVerticalAxis);
				l1.setCustomHorizAxis(chart.getAxes().getBottom());

			}
		});

	}
}
